# Copyright 2019 The FastEstimator Authors. All Rights Reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ==============================================================================
from typing import TYPE_CHECKING

import lazy_loader as lazy

__getattr__, __dir__, __all__ = lazy.attach(__name__,
                                            submodules={'augmentation', 'gradient', 'loss', 'meta', 'model'},
                                            submod_attrs={'argmax': ['Argmax'],
                                                          'average': ['Average'],
                                                          'gather': ['Gather'],
                                                          'normalize': ['Normalize'],
                                                          'permute': ['Permute'],
                                                          'reshape': ['Reshape'],
                                                          'resize3d': ['Resize3D'],
                                                          'tensorop': ['Delete', 'LambdaOp', 'TensorOp'],
                                                          'un_hadamard': ['UnHadamard']})

if TYPE_CHECKING:
    from fastestimator.op.tensorop import augmentation, gradient, loss, meta, model
    from fastestimator.op.tensorop.argmax import Argmax
    from fastestimator.op.tensorop.average import Average
    from fastestimator.op.tensorop.gather import Gather
    from fastestimator.op.tensorop.normalize import Normalize
    from fastestimator.op.tensorop.permute import Permute
    from fastestimator.op.tensorop.reshape import Reshape
    from fastestimator.op.tensorop.resize3d import Resize3D
    from fastestimator.op.tensorop.tensorop import Delete, LambdaOp, TensorOp
    from fastestimator.op.tensorop.un_hadamard import UnHadamard
